package net.argius.stew.gui;

import java.io.*;
import java.util.*;

import net.argius.stew.*;

/**
 * XgB
 */
public final class HistoryList implements Serializable {

    /**
     * <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3111202940561952005L;

    private final List list;

    private int position;

    /**
     * HistoryList̐B
     */
    public HistoryList() {
        this.list = new LinkedList();
    }

    /**
     * ̎擾B
     * @return 
     */
    public String get() {
        return (String)list.get(position);
    }

    /**
     * 1O̗擾B
     * @return 
     */
    public String getPrevious() {
        if (list.isEmpty()) {
            return StringClass.EMPTY;
        } else {
            --position;
            adjustPosition();
            return get();
        }
    }

    /**
     * 1̗擾B
     * @return 
     */
    public String getNext() {
        if (list.isEmpty()) {
            return StringClass.EMPTY;
        } else {
            ++position;
            adjustPosition();
            return get();
        }
    }

    /**
     * ݂̑Iʒu𒲐B
     */
    private void adjustPosition() {
        if (position < 0) {
            position = list.size() - 1;
        } else if (position >= list.size()) {
            position = 0;
        }
    }

    /**
     * ̒ǉB
     * @param history 
     */
    public void add(String history) {
        if (list.contains(history)) {
            list.remove(history);
        }
        list.add(history);
        position = 0;
    }

}